                    +-------------------------------+
                    |          CHANGE LOG           |
                    |      for Ultimate Editor      |
                    +-------------------------------+

Version 0.9.0dev4 (28-Jun-2023 - unreleased)

    General:

    - improved 16-bit TGA conversion GUI
      - added progress & cancel option
      - changed to auto-scale the layout
      - fixed conversion if loaded with another bit depth (broken since UE 0.9.0dev1)
      - fixed to properly ask for file overwrite
    - improved and fixed UE worker task cancellation
      - implemented cancellation for the image conversion
      - fixed export all cancellation for the modified files GUI (broken since UE 0.7.2dev5c if not before)
      - fixed to cancel ship model load, import and rename (broken since UE 0.7.2dev5c if not before)
      - fixed to cancel the map cleanup (broken since UE 0.9.0dev1)
    - improved existent target file replacement
      - changed to also create temporary files when not overwriting the source
      - changed to also backup target files when not overwriting the source
    - improved to center the 'convert addresses' tool layout
    - fixed and improved backup restore
      - changed to not delete newer backup files
      - changed to load backup data without instant file replacement
        - allows to peek at different versions
        - uses save to backup the current version on overwrite
      - changed to reopen previous view after restore
      - fixed to not skip the backup restore procedure (broken since UE 0.9.0dev1)
      - fixed to update backup restore entries on save (broken since UE 0.9.0dev1)
      - fixed backup restore to select files by file name timestamp (broken since UE 0.9.0dev1)
        - previously used the last modification time, which however is not set by the backups any longer
    - fixed to resolve windows library folder paths (broken since UE 0.7.2dev5c if not before)
      - e.g. when converting TGA files from the windows picture library
    - fixed worker execution to close the cancel dialog when there is no work
    - fixed files GUI for listing added file details (broken since UE 0.9.0dev1)
      - in addition fixed the added file hex comparison
    - fixed to reset edit menu when settings view is open on close (broken since UE 0.9.0dev1)

    Trek:

    - improved segments GUI to list and edit string values

    Stbof:

    - improved "Add/Remove Ship Model" GUI
      - added i_*270.tga wide screen image import & export
      - added checks for missing or incompatible WDF images
        - with alert icons for compatibility or load errors
        - and icons for alien and starbase models
      - rearranged buttons & changed to auto-scale the layout
      - fixed ship model import (broken since UE 0.9.0dev1)
      - fixed empty selection errors (broken since UE 0.7.2dev5c if not before)
      - fixed integrity checks to clear previous load errors
    - improved TGA integrity checks to check WDF file requirements
      - also checks trek.exe on the file names for better mod compatibility
      - implemented for edifice.bst, shiplist.sst, techtree.tec and race.rst
    - improved WDF editor GUI
      - changed to hide the root tree node
      - fixed to collapse WDF tree nodes (broken since UE 0.7.2dev5c if not before)
    - improved building stats GUI
      - added sync AI build requirements checkbox
      - changed to auto-scale the structure description
      - fixed to save AI building requirement id changes (broken since UE 0.7.2dev5c if not before)
    - improved AI building requirements GUI
      - added sync energy requirements button
    - fixed star- and ship names GUI import & export to use the work path
    - fixed to edit added buildings in building stats GUI (broken since UE 0.8.1dev1)
    - fixed race name address updates (broken since UE 0.9.0dev1)
    - fixed to not delay the animation start (broken since UE 0.9.0dev1)


Version 0.9.0dev3 (31-Mar-2023)

    General:

    - added new start page
      - shown on startup, after file close and on file load errors
      - with version info and update check
      - with readme, help and changelog access (also added to help menu)
      - with AFC project page and GitLab links (also added to help menu)
      - with easy file access
        - for configured trek.exe and stbof.res
        - related savegames
        - and recent files
    - added VSCode build support
    - implemented new update check function to look for new versions of UE
      - now looks up the releases tags on GitLab project page
      - added option to also search for development versions
      - reduced default update interval from 30 to two days
      - changed to log last update check RFC time
    - implemented to store last open file already on file open
    - increased default run.bat max memory allocation to 8GB
    - improved file save
      - added save cancel & investigate options
        - both abort full save procedure, no partial files saved
      - fixed to not mark internal files saved if not completed successfully
      - fixed to update the window title on changed file name
      - fixed to update recent files on save
    - improved file load to automatically open default views
      - opens the new internal segment list for trek.exe
      - opens the new game stats overview for .sav files
      - opens the file list view for stbof.res and alt.res
      - opens the sound list view for the .snd files
    - improved main menu
      - added panel reload
      - added edit menu separators
      - re-grouped the menu entries
        - logically grouped the menu entries
        - disabled entry sort to keep same position on language change
        - moved options to top menu where the space permits
    - improved settings GUI
      - added update interval setting
      - changed to auto-scale the layout
      - changed to always try load secondary files (trek.exe)
      - grouped the settings
      - implemented to auto-change loaded savegame stbof.res & trek.exe paths
      - merged auto-update file path options
    - improved the files GUI
      - added class type and status columns
      - added remove and discard confirm menus
      - added raw file export option to bypass UE parsing transitions & errors
        - imported files are generic anyhow, but for export it helps when UE corrupts files
      - added movable splitter to reduce or increase the status field
      - added hex change comparison
      - added sneak checking option
      - added load, load all and discard selected files options
      - implemented to restore the selection when changed or reloaded
      - implemented to auto-select added files
      - implemented to save the checkbox selections
      - improved search to filter ctrl+a, delete and other control key down events
      - fixed update when there are no files / all got removed
      - fixed to restore selection when sorting is changed
      - fixed to ignore tab character from opening the search box
    - improved worker progress updates
      - added all file & segment load progress in files & segment GUI
      - implemented to skip too frequent updates that otherwise freeze input
    - improved calculator GUI
      - implemented to accepted decorated hex values
      - fixed to detect negative hex values starting with 0xC
      - fixed to parse large negative hex values that have not all the first four bits set
        (values that are starting with 0x8-0xE)
      - fixed to parse negative floating point hex values
    - improved exception handling and error notifications
      - added text selection & scroll bars to the error notifications
      - changed to collect errors to fix repetitive error popups
        - savegame galaxy map:
          - added map & military list error tooltips with exception details
          - changed to collect sector errors with duplicates erasure
          - changed to collect military and details list errors
          - changed to collect AIAgent and AITask errors
          - replaced map render error notifications by colored 'error' sector tiles
          - fixed to skip missing task force order errors
        - add/remove ship models GUI:
          - changed to collect ship model load errors
          - fixed to collect import and export errors
          - fixed to skip missing hob file errors that are shown as missing anyhow
          - fixed to list known task force values on error
        - group edit of ship stats GUI
          - changed to collect ship stats change errors
        - buildings GUI:
          - removed automatic description fixture, which raised tons of errors
          - fixed to not proceed on trek.exe save errors
        - starting buildings:
          - changed to collect building load errors
        - in-game text GUI
          - changed to collect text database load errors
        - list of modified files GUI:
          - changed to collect file export errors
        - image to TGA & TGA to ANI conversion tools:
          - changed to collect file load & convert errors
      - changed to keep current panel open when on panel change the new one can't be loaded
      - fixed to not skip initialization of missing key values
        - some views loaded but were left in broken state when e.g. stbof.res is missing
      - fixed worker services to display notifications for reported errors
    - improved german translations
    - improved modified files GUI
      - changed to not translate the stored UE "User Modifications" mod name
        - to fix detection when stored in another language
      - fixed to not auto-create snd description files (by load all archives call)
    - improved TGA file load
      - reduced cached memory footprint by loading & rendering TGAs in native 16bit format
      - improved load speed by pre-loading the TGA data before data conversion
    - fixed to apply final changes before panel change
      - some value changes could have been missed on panel load
        since the previous final panel changes were applied thereafter
    - fixed registry Wow6432Node path lookup to determine default game file paths
    - fixed default settings to check on file existance
    - fixed concurrent shared buffer data load corruption
    - fixed to apply defaults when path settings are emptied
      - which also fixed to not store empty paths when the game install path is not found
    - fixed 16-bit TGA image conversion to not delete the source files

    Trek:

    - added BOP mandatory dilithium fixture
      - renamed "Ship Building and Upgrading" menu item to "Construction & Upgrades"
    - added BOP braced numeric sector id option
    - added ECM special ships race mask modification support
    - added MUM martial law short type building ID fixture
      - to allow move martial law buildings to slots exceeding the max unsigned byte ID of 255
      - sneaks in to also replace outdated MUM custom code relocation
    - added tech level patch from edifice patcher to stbof tech GUI
      - with advanced segment and value checks
    - added new extended space object descriptions patch
      - for up to 30 individual space object descriptions
    - added trek.exe segment list
      - lists all potentially read or written trek.exe segments of UE
      - with selected segment details listing:
        - the segment description
        - load errors
        - diff of unsaved modifications
        - diff of detected changes of loaded files
      - with options to
        - discard changes
        - apply patch segments
        - edit value segments
        - or reset to defaults
    - improved AI ship building sets GUI to center the combo boxes
    - improved ship building and upgrading GUI
      - changed to use ship building mod radio buttons
      - changed to auto-disable the special ships check box
    - improved trek.exe integrity check error messages to list further details
    - improved CD protection view
      - added removed CD protection support
      - fixed CD protection GUI line break & improved layout
    - changed to only apply sneaked in unsigned ship load limit patch on need

    Stbof:

    - improved lexicon GUI
      - increased entry list & text area
      - implemented to add & remove lexicon entries
        - with added trek.exe entry count warnings
      - changed to use icon buttons
      - now defaults initial entry selection
      - improved entry search
        - merged find & find next
        - implemented to proceed search from current selection
        - added reverse search
      - added import / export option
      - added option to replace and number all labels for debugging purposes
      - fixed added lexicon description duplication (broken since UE 0.8.0)
    - improved in-game text GUI
      - changed to auto-scale the layout
      - fixed text list to not unnecessarily shorten the names
    - improved to ensure release allocated memory streams & resources
    - improved technogology field GUI
      - separated technology group edit GUI from TechGUI
        - to logically separate from individual technology details
        - to match the separate building and ship group edit views
      - rearranged the view layout and increased the description text field
      - added technology name text box
      - changed to list all required tech level research points
      - changed to use icon buttons
    - improved building stats GUI
      - added tech map & ignore list size auto-detection
        - the tech level count now is auto-determined by calculating the excessive
          default ignore list size and leveraging the 2 bytes deviation
          of additional tech levels and increased ignore list size
        - fixes to read the MUM building list
      - added tech map & ignore list auto-resize confirm options
        - shows up when adding a building or selecting a tech that
          exceeds current size limitations
      - added settings menu
        - to configure & reset the tech map and building mask adjustments
      - added description fixture tools
      - changed to use icon buttons
      - changed to auto-scale
      - changed to not wait on save but update trek.exe segment changes when the view is closed
        - to allow inspect changes in segments view
      - increased building list size
      - fixed to limit move up buildings
      - fixed prev/next button spacings
      - fixed remove shipyard exception
      - fixed the building upgrade table update for tech independent BOP & MUM compatibility
      - fixed saved no_upgrade id to max signed short value (broken since UE 0.7.2dev5c if not before)
    - improved ship stats GUI
      - added super ray stats for refitted future TNG Enterprise-D heavy cannon
      - added offensive & defensive strength
      - renamed min beam range to firing arc
      - changed to use icon buttons
      - changed to auto-scale the layout
      - changed to list the all race filter first
      - matched navigation & layout with the building stats
      - reduced description width again
      - fixed to load unsigned values for build cost, maintenance, scan range and production
      - fixed to apply changes on ship copy
    - improved group edit ship stats GUI
      - added super ray stats for refitted future TNG Enterprise-D heavy cannon
      - added offensive & defensive strength
      - renamed min beam range to firing arc
      - changed to auto-scale the layout
      - changed to list the all race and ship role filters first
    - improved ships overview
      - separated firing arc from beam range
      - added super ray stats for refitted future TNG Enterprise-D heavy cannon
      - added offensive & defensive strength
      - added shield penetration
      - added weapon multiplier
    - improved "Add/Remove Ship Model" gui
      - fixed to mark renamed entries changed
      - fixed updating the ship model list (broken since UE 0.8.0)
      - fixed to not rename duplicate slot names (broken since UE 0.7.2dev5c if not before)
        - by vanilla ship model segment, there are two HM1 entries listed
        - the 2nd entry slot was renamed to "0", and by the short name
          two additional shared slots "0_" and "0__" were added
    - improved race edit GUI
      - changed to use icon buttons
      - fixed morale view size adjustment on race change
    - improved empire evolution starting planets GUI
      - improved to list the evolution levels by name
      - fixed to not overwrite non-colonizable gas planet evolution levels
      - fixed to restore entry sorting by race id
    - improved AI building requirements GUI
      - moved building list to the left
      - changed to use icon buttons
      - improved layout to auto-scale the building list
    - improved intel GUI
      - added back & fixed the computed multiplier product
      - reduced attack delay threshold precision
    - improved stellar GUI
      - added add/remove buttons
      - added stellar animation and nebula image display
      - replaced combobox dropdown by a scrollable list box
      - implemented to load & update the trek.exe lexicon names & descriptions
        - with fallback to map the names by graph name
      - implemented to patch and auto-extend
        - the trek.exe lexicon name & description mappings
        - the galaxy system & anomaly generation
      - implemented system option to qualify for surrounding planets
      - implemented to update sum, graphic files and list name while typing
      - changed to auto-apply changes
      - fixed GUI layout to not resize while typing
    - improved wdf editor
      - added add/remove widget options
      - removed 3840x3072 image pixel limit
      - implemented some basic image cache memory management
        - maintains an access history to free cached images when memory becomes short
      - changed to skip redundant window nodes
      - fixed rescaled black background rendering
      - fixed to keep images cached on selection change
      - fixed TGA font header data corruption (broken since UE 0.7.2dev5c if not before)
        - the row_height and pixel_data_size values accidentally were saved with wrong data type,
          which misaligned the whole file data
        - further the image data size compution was incomplete
    - improved integrity checks
      - added missing ship name group integrity check
      - added race/tech/structure/ship description offset and duplicate detection checks
      - added tech map and building mask integrity checks
      - added integrity check for building upgrades to be in sequence
      - improved objstruc.smt system & anomaly frequency checks for a more granular reporting
      - improved performance by reducing the archive load
      - fixed informative main building offsets (broken since UE 0.8.0)
      - fixed to not mark palette.lst changed with no actual change
    - fixed planets GUI planet rename on type, size & atmosphere changes
    - fixed race/tech/structure/ship description load
      - fixed to load descriptions with address offset
        - to display descriptions same like loaded by the game
        - to not overwrite and potentially corrupt the addresses
    - fixed to rename planet food & energy bonuses
    - fixed starting buildings to update previous building count on add
    - fixed to sneak back full last voice group size in converse.bin
      - by the increased size it includes a second end delimeter that looks like
        it was meant for convention to signal final sound termination
    - fixed starname.bin string lengths, they faultly were set to full text space
    - fixed texture GUI GIF file load to read the optional GIF extension block and not corrupt it

    Alt:

    - fixed "List Of Modified Files" menu stbof null pointer exception

    Savegames:

    - added new game configuration menu
      - lists starting conditions & selected galaxy generation options
      - extends previous game info options by version, starting seed, difficulty,
        strategic & tactical timer, tactical combat mode, victory condition and events
    - added new game info views
      - displays loaded stbof.res & trek.exe paths
      - displays edited save game corruption warning
        - with weblink to AFC UE forum
      - added general stats with score graph and basic game details
      - added galaxy stats for a general game overview
      - added empire stats for empire comparison
      - does not block, but asynchronously loads the stats
    - improved mod compatibility
      - now supports UDM3, GALM, MUM, BOP and more
      - added extended task force patch auto-detection (UDM3, GALM,...)
      - added extended build queue patch auto-detection (UDM3, GALM,...)
      - added extra system status support (BOP)
      - added modded stellar type support (GALM)
    - impoved galaxy map GUI
      - added draw options to display the system & stellar names
      - added map cleanup dialog to remove task forces, systems, AI tasks and stuff
      - added system index to the sector tooltip
      - added open system edit context menu option
      - added system generation, elimination, remove & maintenance context menus
      - improved bottom system detail list
        - added open system edit button
        - added new planet generator button
        - added planet edit & remove context menus
        - changed to align system items to the right
        - fixed to update dilithium icon on dilithium change (broken since UE 0.7.2dev5c if not before)
        - fixed untracked planet & star selection color (broken since UE 0.8.0)
          - occured on planet & star icon borders when boni or dilithium is present
      - improved bottom taskforce detail list
        - added ship edit & remove context menus
      - implemented to list new stellar object and system types
      - implemented to remember the view options
        - filter options are stored to the settings
        - empire view is cached till the game save is closed
      - replaced target sector selection dialog by new hovered sector selection mode
      - moved save game edit warning to game info
      - darkened unrevealed sector tiles
      - changed to black map background
      - changed to sort context menu entries by usage, to not mess on translated names
      - fixed to not render default pressed blue button sector tile color
      - fixed zoom out scroll position
      - fixed to rename star systems (broken since UE 0.7.2dev5c if not before)
      - fixed to update dilithium icon on dilithium change (broken since UE 0.7.2dev5c if not before)
      - fixed untracked planet & star selection color in bottom system detail list (broken since UE 0.8.0)
        - occured on planet & star icon borders when boni or dilithium is present
    - improved empires GUI
      - added technology level spinners
      - improved the layout to hide scrollbars and use full available space
      - fixed empire info to update known races on empire change (broken since UE 0.8.0)
    - improved systems GUI
      - added view galaxy button with auto system selection
      - changed to restore planet selection
      - changed to auto-select first planet
      - changed no & low bonus selection texts
        - even if zero, planets effectively still have a bonus
      - fixed shrinked gas planet layout
    - improved built structure list
      - added view galaxy button with auto system selection
      - added membered & subjugated system filters
      - changed to list the system controlling race
      - removed excessive column width spacings
      - disabled system name edit
        - should be edited in system info view
        - was broken on selection change
    - improved integrity checks
      - added invalid star base ship model type integrity check
      - added task force order fixture
        - for missing task forces if not lost or dissolved
        - for missing orders and those that list a different task force
        - for incompatible task force missions
      - added GWTForce, GTForceList & GShipList total slot checks
      - added duplicate task force id fixture (same task force is listed more than once)
      - added duplicate task force ship fixture (2 or more ships of same id in same task force)
      - added ghost ship elimination with reverse task force validation
        - when listed by multiple task forces, the task force referenced by the ship itself is preferred
      - added task force id overflow fixture by re-assigning new ids to all the ships
        - updates all the references and reduces the ship id counter
      - added broken systInfo update worker flag fixture
        - which looks to be set by some random events and crashes the game
      - added current turn empire stats index integrity check
      - added invalid diplomatic action integrity check to fix broken war declarations
      - sorted integrity checks to maintain a strict order and check dependent stats last
      - improved galInfo integrity checks to determine and fix the actual counts
      - improved star base info integrity check to remove invalid star bases
      - improved integrity check notification levels
      - improved integrity check descriptions
      - improved performance by reducing the archive load
      - fixed invalid empire mask integrity check for multi-player games
      - fixed extinct alienInfo race integrity check to check all systems
      - fixed max morale integrity check (GALM)
      - fixed planet specials integrity check (broken since UE 0.8.0)
    - fixed UE save game corruptions
      - fixed to read intel & unknown orders with less than 52 content bytes (broken since UE 0.7.2dev5c if not before)
        - which got truncated and crashed the game
        - both for ordInfo and the turn results
      - fixed to operate on GWTForce not GTForceList (broken since UE 0.8.0)
        - to display and edit latest player re-grouped task forces
      - fixed to auto-re-group and update edited GTForceList ship task forces
        - to always match GWTForce ship locations and ownership,
          which otherwise lead to game crashes for player re-grouped task forces
      - fixed to auto-update task force abilities for removed ships
      - fixed task force handling for negative player re-grouped temporary task force ids
        - fixing task force count corruption, which crashed the game
        - fixing unsigned GShipList temporary task force lookup,
          which lead to inconsistent updates and crashed the game
      - fixed to reset task force orders on changed ownership, which otherwise crashed the game
      - fixed task force removal to also remove the corresponding task force results
      - fixed computed task force colonization level (broken since UE 0.8.0)
      - fixed to not drop agreed sector ownership of contested sectors
      - fixed to update the empire stats index along with setting the turn number
    - fixed switched SystemInfo & StrcInfo page titles

    Snd:

    - improved sound GUI
      - english/german.snd improvements
        - added to list sound details: race, [voice group/voice list, voice list type]
        - added unsupported unused sound race selection error notification
        - fixed to not overwrite the sound description races by converse.bin load
        - fixed to set the actually read converse.bin race in addition to the description race
      - changed to auto-scale the layout
      - removed enforced english/german.snd & sfx.snd sound limits
      - fixed to reset search next position on search
      - fixed to not auto-create snd description files on load
      - fixed to remove PCM headers from created big playable SFX file
        - they caused noise at the start of each sound effect
        - the noise left likely are cuts of the wave form, caused by abrubt changes of continuous sounds


Version 0.8.0 (14-Jun-2021)

    General:

    - large code cleanup
        - updated for Java 8+ runtime environment compatibility
        - replaced build scripts by the gradle build system
        - fixed about 1000 compile warnings including some minor bugs
        - fixed a number of resource leaks
        - formatted lots of messed code
    - added Eclipse build support
    - added opened file name to the window title
    - enabled experimental features by default
    - updated the readme build instructions

    Trek:

    - fixed trek.exe verification for enlarged file size,
      now checking for the "STBOF.RES" name at 0x173E38 rather than the file size

    Stbof:

    - fixed WDFEditor mouse click event sometimes not fired
    - fixed extended shipname.bin file format
        - note that with current trek.exe patch, the first extended group 62
          includes last entry from group 61
    - disabled to auto-patch trek.exe for extended ship name groups
        - it now will show a warning to externally patch trek.exe
    - increased character limit for ShipStat GUI from 40 to 80
    - added to display the race info selection index
    - increased max wdf display size for 4k editing
    - building stats
        - changed to allow edit the tech level selection
        - fixed add to default removed build requirements
        - fixed remove to update race tech availability building indices
        - fixed remove to update special ship building index
        - fixed remove to default referencing upgrade indices to max short
        - fixed move to update switched description addresses
    - starting conditions
        - improved selectable tech levels for the starting buildings & starting technology tabs
            - now checks for available building technology levels, filtered by the race mask selection

    Savegames:

    - fixed map, task force & details right mouse click event sometimes not fired
    - fixed sav file corruption issues
        - improved systInfo extended build queue read error adaption
        - disabled pre-initialized LZSS compression dictionary lookup feature
            - this potentially corrupted any modified save game
        - fixed to update or reset task force missions, AITasks and orders
            - reset local system missions for moved task forces
            - reset local system missions on target sector star system and stellar object move
            - update mission, order and AI task target sectors on star system and stellar object move
            - reset enter wormhole mission on removed target sector wormhole
        - fixed to update GalInfo outpost count for added outposts and starbases
        - fixed systInfo unknown variable corruption, overridden by 2nd index
        - fixed empsInfo uncompressed file size corruption, which lead to
            - File: ..\..\source\game\solarapi.c, Line: 2792,
              System is not dest or source of trade route
        - fixed strcInfo auto-resolve of duplicate structure entries
            - when e.g. duplicate isolinear-scanners are present, on load it merged the count
              but on save it erronously wrote the entry twice, doubling the building count
    - improved sav integrity checks
        - corrected some warning labels
        - implemented to automatically add or correct the id counters
            - for AIAgtIdCtr, AITaskIdCtr, ShipCntr, TForceCntr
        - fixed membership integrity checks for subjugated and extinct minors
        - fixed not met races with treaty integrity correction
        - fixed to process task force checks in sequence
        - added missing ship & task force integrity checks, to e.g. fix:
            - File: ..\..\source\game\ship.c, Line: 968,
              taskForce != NULL
        - fixed to mark GameInfo & StarBaseInfo fixture changes
    - improved and re-arranged map ui layout
        - added sav corruption warning
        - center map both horizontal and vertical
        - fixed sector tooltip to not double "Sector" for the name
        - fixed clipped ship details description
        - fixed reduce 2nd row task force ship spacing
        - changed selection color
    - implemented to change known races
    - added sector hex position and index to the sector tooltips
    - added new task force context menus
        - to add new task forces with configurable ship count
        - to clear task force orders
        - to change task force ownership
        - to remove task forces
    - improved hex id lookup
        - changed to sort AgtSh, AIShpUnt, TskSh ship entries by id
        - changed to sort alienTFInfo, monster.lst task forces by id
        - changed to sort starBaseInfo outposts and star bases by id
    - implemented to sort the sav file entries to match trek.exe file order


Version 0.7.2dev5c (03-Apr-2012)

    Stbof:

    - primitive farms (main food buildings at level 0) are now set to group 5
    - shipyards allowed in AI building requirement list


Version 0.7.2dev5b (07-Mar-2012)

    Stbof:

    - fixed bug that caused shipname.bin corruption when the number of name groups
      was extended

    Savegames:

    - system requirement flags will now be properly set in systInfo file
    - two minor fixes to Galaxy screen


Version 0.7.2dev5a (10-Jan-2012)

    Stbof:

    - enabling custom phaser and torpedo hob files in Ship Stats now sets phaser
      and torpedo prefixes in shiplist.sst to the default values as it should

Version 0.7.2dev5 (09-Jan-2012)

    General:

    - fixed a bug that caused exceptions to be thrown when viewing list of modified files
      (bug reported by Thunderchero)

    Stbof:

    - added options to set phaser and torpedo hob files per ship in Ship Stats using
      Spocks-cuddly-tribble's trek.exe and shiplist.sst modifications

    Savegames:

    - attempt at fixing a bug that causes EmpsInfo not to save properly
      (bug reported by mjwx and EnPhreg)

    Trek:

    - added the selectable per ship phaser and torpedo hob file option
      (trek.exe modification by Spocks-cuddly-tribble)


Version 0.7.2dev4 (07-Nov-2011)

    Stbof:

    - added command Intel->Intel Multipliers and support for extended shipname.bin
      (mod info provided by Spocks-cuddly-tribble)

    Trek:

    - fixed ShipModelData so it no longer places duplicate entries to the end of
      the phaser slot list on data load (bug noticed by Thunderchero)


(Version 0.7.1b - 07-Nov-2011)


Version 0.7.2dev3b (03-Oct-2011)

    Stbof:

    - minor cosmetic change in "Starting Technology" screen
    - fixed bug where ship scan range was being set to map speed
    - added dynamically setting wdf screen size based on the wdf window dimension


Version 0.7.2dev3a (07-Sep-2011)

    Stbof:

    - removed buildings being set based on minor race personality by automark/all

    Trek:

    - fixed bug where some of the martial law ids for the Ferengi and Federation
      were switched


Version 0.7.2dev3 (06-Sep-2011)

    General:

    - fixed minor bug that would put the UE window out of it's place when maximized
    - errors on saving changes in a screen will now prevent file saving/closing as
      well as switching to another screen

    Stbof:

    - removed useless edit command "Major empire tolerance"
    - building ids used in trek.exe can now be set under Building Stats
    - rewritten the way automark/all buttons work in "Starting Technology" and
      changed layout a bit

    Trek:

    - fixed bug in GalacticMapGUI that would cause trek.exe corruption


Version 0.7.2dev2b (24-Aug-22011)

    General:

    - fixed bug in Edifice.java where UE would use the first shipyard buildable
      by an empire as that empire's native shipyard


Version 0.7.2dev2a (13-Aug-2011)

    General:

    - minor bug fixes
    - disabled max memory settings since it turned out to be problematic


(Version 0.7.1a - 13-Aug-2011)


Version 0.7.2dev2 (12-Aug-2011)

    General:

    - UE gives itself more max memory - no need to use the *.bat file unless the
      app asks you to do so

    Stbof:

    - fixed bug in Edifice integrity check where UE had used fixed ids of morale
      buildings instead of actual ids
    - added per file image caching on WDFEditorGUI to speed up image loading and
      reduce memory usage
    - fixed object casting bug in ShipModelGUI

    Trek:

    - UE will now edit AI scan range when the galactic map size is changed
    - added 8 dilithium refinery ids
    - added 4 basic shipyard ids
    - added 6 orbital battery ids
    - added 1 federation level 1 farm id
    - added 3 basic ground defense building ids
    - added 2 basic shield generator ids
    - added empire shipyard ids
    - added 2 sets of morale building ids


Version 0.7.2dev1 (06-Aug-2011)

    Stbof:

    - added command Graphics -> Graphical User Interface


Version 0.7.1 (06-Aug-2011)

    General:

    - running UE from a link should work now in Vista/Win7 even if "Start In" isn't set
    - in Settings added option to enable experimental features (default set to off)
    - exception stack traces are now filtered to make error log entries smaller
      (can be disabled in settings.ini by setting useExceptionFilter to No)
    - added file size tab to FilesGUI (displayed on Files commands)
    - on the Files screen the file list starts sorted by name
    - added a search feature to the Files screen (typing while the file list
      is selected will now search for files starting with the given string)
    - UE no longer asks to save secondary files if an error occured during saving
    - added option to change font size and style
    - backup files now have date and time in their name which has precedence over
      the timestamp on the file when determining the age of the backup file
      (old backups will continue to work)
    - setting the number of backups for the first time now displays a warning about backup size
    - added run.bat for convenience in case double clicking on UE.jar fails to work
    - changed the updates check routine to check every 7 days instead of every day

    Stbof:

    - remade TechGUI (Edit->Technology->Technology Fields) from scratch,
      added options for editing all techs/fields at once
    - UE now stores stbof file list in memory which makes checking if a file
      is in stbof.res a bit faster
    - added command Ships->Ships Overview
    - added option to add/remove planets on the Planets screen
    - improved removal of unused palettes
    - renaming major race planets under Galaxy->Planets now also renames them in meplanet.bin
    - added experimental option to add new technology under "Technology Fields"
    - UE will now remove unused entries from aiminor.wtf when Check integrity is run
    - allows setting tech requirement to values above level 9 for buildings
    - enabled options to add/remove buildings
    - Edifice now updates number of buildings in trek.exe (thanks to Peter1981 for the offsets)
    - added additional checks and error fixing to AIBldReq Check Integrity
    - when importing/exporting models UE now compares md5 hashes of imported/exported textures
      and if it finds a match uses the existing texture instead of creating a duplicate
    - number of buildings in trek.exe is now updated only if it doesn't match edifice.bst
    - maximum number of buildings is limited to 384 (racetech.tec limitation)
    - animation transparency in the Animations screen can be switched on/off
    - in Group Edit of Building Stats bonus indexes are now shown
    - fixed BuildingGUI to no longer include bonus index to it's description when edited
    - removed ship map speed limit which was set to 5
    - improved the layout of ShipnameGUI and StarnameGUI
    - added options for importing and exporting names to ShipnameGUI and StarnameGUI
    - small improvement to the way TGA frames are extracted from animation files
      in the animations screen

    Trek:

    - added screen help for Game->Ship Building
    - added Check Integrity check for the builable minor ships option
      to check number of available ships for every race
    - renamed command "Ship Building" to "Ship Building and Upgrading" and
      added options to turn on/off auto-upgrade of ships and outposts
    - added additional main buildings starting ids
    - added martial law ids
    - added basic scanner ids
    - added orbital battery ids
    - added basic shield generator ids
    - added trade goods ids
    - added special structure id
    - added minor race main building min and max ids
    - added 3 basic shipyard ids
    - added minor race special building ids
    - added even more main building ids
    - added aditional code modification checks to prevent trek.exe corruption when
      it contains unknown modifications
    - removed support for original trek.exe, supporting Joker's patch only from now on
    - added new command option: Patches and bug fixes (contains only one patch option atm)
    - added another orbital battery id (thanks to Thunderchero)

    Savegames:

    - morale of a system can now be set to 0
    - added command Empire Info
    - added option to edit the lists of built structures
    - replace the old map screen with an updated one that has all the features of the old one
      and also moves ships when switching sectors


(Version 0.7.1dev13b - 30-Jul-2011)
(Version 0.7.0l      - 30-Jul-2011)
(Version 0.7.1dev13a - 05-Apr-2011)
(Version 0.7.0k      - 05-Apr-2011)
(Version 0.7.1dev13  - 19-Mar-2011)
(Version 0.7.1dev12  - 14-Feb-2011)
(Version 0.7.0j      < 06-Dec-2010)
(Version 0.7.1dev11e - 24-Nov-2010)
(Version 0.7.1dev11d < 10-Nov-2010)
(Version 0.7.1dev11c - 20-Sep-2010)
(Version 0.7.1dev11b < 03-Sep-2010)
(Version 0.7.0i      < 26-Aug-2010)
(Version 0.7.1dev11? - 16-Aug-2010)
(Version 0.7.1dev10  < 13-Aug-2010)
(Version 0.7.1dev9?  - 05-Aug-2010)
(Version 0.7.1dev8?  - 27-Jul-2010)
(Version 0.7.1dev7?  - 26-Jul-2010)
(Version 0.7.1dev6?  - 25-Jul-2010)
(Version 0.7.1dev5e  - 08-Jul-2010)
(Version 0.7.0h?     - 08-Jul-2010)
(Version 0.7.1dev5d  - 26-May-2010)
(Version 0.7.0g      - 26-May-2010)
(Version 0.7.1dev5c  - 22-May-2010)
(Version 0.7.1dev5b  - 21-May-2010)
(Version 0.7.1dev5a  - 12-May-2010)
(Version 0.7.1dev5   - 09-May-2010)
(Version 0.7.1dev4a  - 08-May-2010)
(Version 0.7.0d      - 08-May-2010)
(Version 0.7.1dev4   - 18-Apr-2010)
(Version 0.7.0c      - 18-Apr-2010)
(Version 0.7.1dev3   - 08-Apr-2010)
(Version 0.7.1dev1a  - 10-Dec-2009)
(Version 0.7.0b      - 10-Dec-2009)


Version 0.7.0 (24-Nov-2009)

    General:

    - UE now tries to find botf install directory on non-Windows platforms with Wine installed
    - added links to Thunderchero's UE Basics tutorial
    - added links to Thunderchero's tutorials on map generation and adding ships to Screen Help
    - added link to Dr Breen's tutorial on reducing number of palettes to Screen Help
    - got rid of ZipWriter
    - added setting WORK_PATH to SettingsManager
    - FilesGUI is now using WORK_PATH as source/destination path
    - added batch files equivalent to the existing bash scripts
    - dialog is now resized on sentMessage in UEWorker to be able to show the whole message
    - code clean up, internal changes

    Stbof:

    - improved Aiminor Check Integrity function
    - on rename race in the Race Info panel UE now also edits aiminor.wtf, meplanet.bin and trek.exe
    - in TextureGUI list only valid textures (whose filenames end with ".gif")
    - added command Buildings->Buildings Overview (based on Gowron's BuildView2)
    - if aiminor.wtf and trek.exe entries mismatch, entries in trek.exe get renamed now

    Savegames:

    - added dilithium icon setting to systInfo (thanks to Thunderchero)
        - improved systInfo entry detection
    - sector names now display properly for large maps

    Trek:

    - added "Galaxy Generation" screen
    - changed starbase check in SpecialShips to work with the Flagship mod
    - added option to enable minor ship building in minor systems (Edit->Game->Ship Building)

    Snd:

    - added info output to Check Integrity for english.snd
    - added option to set race to use voices of another race (action can't be undone by UE)
    - english.snd voice owners are read from converse.bin now
    - added option to switch race voices for english.snd
    - English.java is now using UEWorker

    Tools:

    - fixed destination path annoyance in Image2TgaGUI (now using WORK_PATH)
    - added command Tools->Other->Convert Addresses


(Version 0.7.0rc6    - 23-Nov-2009)
(Version 0.7.0rc3    - 31-Oct-2009)
(Version 0.7.0h      - 31-Oct-2009)
(Version 0.7.0dev12a - 23-Sep-2009)
(Version 0.7.0dev10  - 04-Jul-2009)
(Version 0.6.9g      - 04-Jul-2009)
(Version 0.6.9f      - 12-Jun-2009)
(Version 0.6.9e      - 11-Jun-2009)
(Version 0.7.0dev6   - 16-May-2009)
(Version 0.7.0dev4a  - 06-May-2009)
(Version 0.6.9d      - 06-May-2009)
(Version 0.7.0dev4   - 06-May-2009)
(Version 0.6.9c      - 06-May-2009)
(Version 0.7.0dev3   - 04-May-2009)
(Version 0.6.9b      - 04-May-2009)
(Version 0.7.0dev1   - 27-Apr-2009)


Version 0.6.9 (05-Apr-2009)

    General:

    - fixed bug that caused changed files writen to a stream be marked as not changed
    - fixed bug in FileManager that caused UE to be unable to open snd files
    - improved FilesGUI a bit including adding font preview
    - added option to make backups when saving files and restore them,
      number of backups can be set, backups can be selected from menu
    - cleaned up SettingsManager
    - UE now tries to find secondary files in the folder of the file opened
      before opening default files

    Stbof:

    - fixed bug in Texture that caused texture removal not to count as a change
    - ship models not used are removed from screensaver list in ShipGUI
    - added command AI Ship Building Sets
    - when auto setting available buildings in Starting Technology
      UE will only set buildings as available for minor races if system
      and political requirements of the building fit
    - BuildingGUI allows moving buildings up/down

    Trek:

    - fixed SpecialShips to also accept comparison to class instead of ship id
    - UE now updates puny farm and factory ID's in trek.exe


(Version 0.6.9dev6e - 28-Mar-2009)
(Version 0.6.8b     - 22-Feb-2009)
(Version 0.6.9dev2  - 17-Feb-2009)
(Version 0.6.8a     - 10-Jan-2009)


Version 0.6.8 (10-Jan-2009)

    General:

    - fixed update checking
    - when a TGA file is selected in Other->Files screen it's type and pixel depth
      are tested and if invalid an error message is displayed
    - compatible with Gowron's BOP 1.1
    - minor fix in AniOrCur
    - when saving files, UE now asks if you want to also save the secondary files
    - fixed bug that doubled the size of generic files
    - "Save As..." can now be used even if no changes were made to the open file
    - reduced memory usage of loaded ship packages

    Stbof:

    - negative planet bonus values are now allowed
    - fixed CheckGUI line wrapping
    - when changing building's energy cost - the value in aibldreq.bin gets
      updated as well unless the cost there doesn't equal to the old cost in edifice.bst
    - added command Edit -> AI -> AI Building Requirements
    - fixed Edifice, PaletteList and HobFile to not erronously report changes
    - bug fix: AiMinor didn't register a change when a misnamed entry was fixed by
      Check Integrity
    - improved check integrity in Edifice
    - one can now set and view a preview jpg image and author in
      Add/Remove Ship Models panel
    - ships from pack are no longer sorted by name in Add/Remove Ship Models panel
    - added option to set building's group in BuildingsGUI
    - in Add/Remove Ship Models the tooltips now show hob file size

    Savegames:

    - cleaned MapGUI.java and fixed minor cosmetic issues
    - MapGUI now updates StellInfo's "visited by empire" info
    - StarBaseInfoGUI allows setting outpost ship type and hull
    - MapGUI allows adding/editing/removing stellar objects and outposts
    - fixed bug that caused UE not to register a change when certain files
      were added to the saved game

    Trek:

    - race names used in sync with aiminor.wtf are now repositioned in trek.exe
      which allows longer minor race names.
    - main buildings are now auto set in trek.exe when edifice.bst is saved


(Version 0.6.8dev12 - 03-Jan-2009)
(Version 0.6.8dev3  - 15-Nov-2008)
(Version 0.6.7d     - 15-Nov-2008)
(Version 0.6.8dev2  - 19-Oct-2008)
(Version 0.6.7c     - 19-Oct-2008)
(Version 0.6.8dev1a - 18-Oct-2008)
(Version 0.6.7b     - 18-Oct-2008)


Version 0.6.7 (17-Oct-2008)

    General:

    - added option to check for updates once a day when UE is run under Settings (default off)
    - ModifiedFilesGUI is now using UEWorker for background tasks
    - in Modified Files window one can now choose to only extract the selected files
    - Modified Files dialog now lists all game data files and allows user to export all of them at once
    - under Settings added option not to load secondary files unless they're essential
    - errors thrown in UEWorker thread now also print UE version and date to error log
    - Other->Files now displays a preview of the selected file (works for .tga, .gif, .cur and .ani files)
    - cleaned up code in packages ue.edit.res and ue.edit.mod
    - files can now be sorted by their type in Other->Files

    Stbof:

    - technology field names can be edited in the Technology Fields screen
    - Check Integrity will try to fix sinhronization errors between aiminor.wtf and trek.exe
      (an example of this is the Antedian bug) but only if trek.exe can be opened
    - when renaming aiminor entries under Edit->AI->Minor Race Attitudes trek.exe is updated
      as well as aiminor.wtf (but not if the entry is already out of sync or trek.exe can't be opened)
    - when hovering your cursor over a ship model's data, UE will now display class (if available)
      and size of textures the model is using. (ShipModelGUI)
    - added ability to have up to 264 ships in the shiplist (thanks to Gowron)
    - models in Add/Remove Ship Models are now ordered by owner and ship class
    - textures can be removed in Graphics->Textures
    - lists of textures under Graphics->Textures and Graphics->Hob Files are now sorted
    - Edifice now checks build costs of building upgrades when Check Integrity is run

    Alt:

    - Alt.java is now using UEWorker instead of SwingWorker for background tasks

    Trek:

    - added command: Ship Map Ranges


(Version 0.6.7rc1   - 11-Oct-2008)
(Version 0.6.7dev10 - 16-Sep-2008)
(Version 0.6.6j     - 16-Sep-2008)
(Version 0.6.7dev9a - 16-Sep-2008)
(Version 0.6.7dev9  - 15-Sep-2008)
(Version 0.6.7dev8  - 11-Sep-2008)
(Version 0.6.6i     - 11-Sep-2008)
(Version 0.6.7dev7  - 10-Sep-2008)
(Version 0.6.6h     - 10-Sep-2008)
(Version 0.6.6g     - 07-Sep-2008)
(Version 0.6.7dev3  - 06-Sep-2008)
(Version 0.6.6f     - 06-Sep-2008)
(Version 0.6.7dev2  - 05-Sep-2008)
(Version 0.6.7dev1  - 05-Sep-2008)
(Version 0.6.6e     - 05-Sep-2008)
(Version 0.6.6d     - 04-Sep-2008)
(Version 0.6.6c     - 02-Sep-2008)
(Version 0.6.6b     - 01-Sep-2008)


Version 0.6.6 (22-Aug-2008)

    General:

    - code cleaned up in packages ue, ue.edit, ue.edit.exe, ue.edit.exe.trek
    - only show relevant files when setting stbof.res or trek.exe under Settings

    Stbof:

    - added command Edit->Graphics->Add/Remove Ship Models
    - under Ship Stats ships can be set to appear in the screensaver
    - added variables to Edit->Group Edit of Building Stats -> see it's Screen Help
    - updated help files


(Version 0.6.5d - 04-Aug-2008)
(Version 0.6.5c - 14-Jul-2008)
(Version 0.6.5b - 14-Jul-2008)
(Version 0.6.5a - 13-Jul-2008)


Version 0.6.5 (13-Jul-2008)

    General:

    - file manager checks for changes in all open files not just the main one
    - support for html help files (external links are ignored)
    - MainWindow resize and minumum size tweaked
    - fixed translation bug in CalcGUI

    Stbof:

    - added option "Behave as if built by" to override ship combat behavior in ship stats
    - fixed minor translation bug in Planet.java
    - planet ID duplications are now auto-fixed when Check Integrity is run
    - fixed a bug in error reporting in Stbof.java
    - fixed display bug in AiminorGUI.java
    - AiminorGUI.java now displays a warning on editing aiminor.wtf race names
    - special ships can be set under Ship Stats (works for all empires, maximum number of special ships is 5)
    - ShipGUI.java now reports an error when ship image is not found instead of silently breaking
    - added option to allow a building to build special ships (also allows "less or equal than" hack)
    - improved buildings group edit -> added filter by empire and support for equations [L,*,/,^,+,-,(,)]
    - minor fixes (Create Copy, Remove, GUI) in ShipGUI.java
    - minor changes in ColValGUI, AiepmireGUI, AiminorGUI, BldSetGUI, BuildingsGUI, ShipMultiGUI
    - minor changes in MaxPopOrBonGUI, ObjstrucGUI, RaceInfoGUI, LexiconGUI
    - Group edit of ship and building stats have a 5 second cooling time on each operation
    - fixed bogus ship map range checking in Check Integrity
    - fixed translation bug in StartConGUI
    - fixed erronous orbital battery id check when testing graphics files
    - fixed upgrade bug that happened when copying ships
    - fixed Morale Penalties file

    Alt:

    - fixed bug in Alt.java

    Savegames:

    - some fixes in MapGUI
    - fixed checking of overlapping entries
    - fixed critical bug on reading/setting game name
    - fixed bug that caused loaded files seemingly disappear (due to invalid file names being set)

    Exe:

    - added another alien starting id to set, this should fix the problems with added ships
    - added two more alien starting ids


(Version 0.6.4a - 09-Jun-2008)


Version 0.6.4 (09-Jun-2008)

    General:

    - code cleanup
    - added translation support
    - added German translation (thanks to Siggi)
    - added partial Slovenian translation (for testing purposes)
    - user can only shrink the main window to it's minimum size (depending on panel)
    - user can change font type used for UE's GUI
    - got rid of the data folder (essential data moved into jar)
    - check integrity screen now has a regular text box - this allows easy text copying
    - sometimes AboutGUI wasn't showing correctly, this is now fixed
    - AboutGUI can now list multiple authors
    - fixed bug: when converting images the file extension is now changed to TGA
    - trek.exe can now be opened with the editor (not all versions supported)
    - saving files now works properly under linux

    Stbof:

    - ships can be added or removed from shiplist (requires trek.exe to be set in settings)
    - added a very simple group edit for buildings
    - ships are marked if they are special or not
    - slightly improved HOB editing
    - fixed cosmetic bug in ShipGUI that caused the ship list to jump sometimes
    - fixed minor bug in hasInternalFile() in Stbof.java
    - fixed Colval.java value checking
    - check integrity command re-enabled
    - fixed change detection
    - fixed description not found bug in TechGUI

    Alt:

    - adding/removing files works the same as for stbof.res,
      save changes using File->Save

    Savegames:

    - fixed minor cosmetic bug in MapGUI.java
    - adding/removing files works the same as for stbof.res
      save changes using File->Save
    - extracting/adding result.lst now works as it should (thanks to Flocke)

    Exe:

    - added option to enable/disable the CD protection
    - added command: Starting Conditions (allows changing starting population and credits)


Version 0.6.3

    General:

    - modified files can now be extracted in the Other->Modified Files window
    - opening Modified Files window now disables the main window
    - fixed default settings
    - removed GIF image separator check
    - fixed GifImage.java

    Stbof:

    - when number of palettes goes over 127, the text showing the number will turn red
    - fixed bug in TextureGUI.java - invalid GIF would still be added to texture.lst
    - fixed GUI component positions in TextureGUI.java
    - should no longer be case sensitive when reading files
    - fixed error in HobFile.java that caused a NullPointerException when the file was saved
    - fixed error in HobFile.java that caused false file size to be returned
    - fixed Texture.java to mark changes


Version 0.6.2

    General:

    - fixed problem with dialogs
    - removed support for UE mods (old and not relevant)
    - moved to Java version 6

    Stbof:

    - ship map range of -1 (None) and 3 (Towable) are now allowed
    - disabled command Check Integrity (this is a temporary solution)
    - added functionality: can change combat radius for hob files
    - fixed StringFile.java
    - fixed HobGUI.java (UE now shows correct combat distance)
    - fixed RaceInfoGUI.java - race should no longer switch when changing the name
    - fixed MoraleGUI.java - all races should now be visible in the window


Version 0.6.1

    General:

    - fixed GameMonitor.java

    Stbof:

    - when editing multiple ship stats one can choose if the
      calculated values should be rounded up, down or to the nearest
      number.
    - added command: Edit->Graphics->HOB files
    - added command: Edit->Graphics->Textures
    - removed command: Edit->Graphics->Register Textures
    - fixed bug in Edifice.java
    - fixed minor bug in ShipGUI.java
    - cleaned up Texture.java - no more warnings on textures not
      using their own palettes
    - fixed getNumberOfEntries() in Palette.java
    - fixed some more minor bugs in ShipGUI.java
    - fixed StringFile.java
    - fixed minor bug in MainMenu.java
    - fixed another bug in StringFile.java

    Snd:

    - fixed Sfx.java


Version 0.6.0

    Stbof:

    - fixed bug that caused some files added not to show up
      in the Modified files list, making Mod Creator to ignore them
    - when one registers textures UE will show you the number of
      registered textures and palettes.
    - improved BldSetGUI
    - improved StartConGUI
    - fixed bug in BuildingsGUI
    - fixed bug with the edifice.bst ignore list

Version 0.5.9

    Stbof:

    - added functionality: Colony Value
    - one can now edit planet atmosphere
    - fixed bug in PlanetGUI that caused false planet data to be shown
    - minor changes


Version 0.5.8

    Stbof:

    - improved support for planet.pst
    - improved Starting Buildings screen
    - improved Starting Technology screen
    - improved Planets screen
    - fixed bug in MaxPopOrBonGUI
    - fixed bug in PlanetGUI
    - fixed bug in Edifice


Version 0.5.7

    Stbof:

    - fixed meplanet.bin bug


Version 0.5.6

    General:

    - some minor stuff fixed

    Stbof:

    - fixed saving file

    Mods:

    - fixed the problem with wrongly sorted properties in stbof.ini


Version 0.5.5

    Stbof:

    - in BuildingsGUI: redone the buildings filters and also reduced the
      number of images shown to only those which might be relevant


Version 0.5.4

    General:

    - black color in GIFs is treated as transparent


Version 0.5.3

    General:

    - more minor stuff
    - removed some bogus GIF checking

    Mods:

    - fixed reading stbof.ini


Version 0.5.2

    General:

    - minor improvements

    Mods:

    - added functionality: UE can now install files to the English
      folder within the game dir. If the folder doesn't exist it
      will be created by UE
    - added functionality: once you create your mod, open it, under edit
      you'll find some switches, they are used to write values to
      stbof.ini
    - if you use the no-cd switch make sure you add a cracked trek.exe
      and the audio/video files from the english folder to your mod


Version 0.5.1

    General:

    - fixed bug in Convert
    - switched from using ASCII encoding for strings to ISO-LATIN-1

    Stbof:

    - in BuildingsGUI the index of the building is shown
    - added sinchronisation between shiplist.sst, shiprace.sst and
      shiptech.sst to make sure moving ships in shiplist works with np

    Alt:

    - fixed bug that disabled saving

    Mods:

    - fixed bug that caused UE to fail replacing files installed to
      the game directory with the ones from the uninstaller

Version 0.5.0

    Stbof:

    - added functionality: Register Textures
    - fixed bug in ShipGUI, that mixed the tech req. when moving ship up

    Util:

    - added functionality: Calculator


Version 0.4.9

    Stbof:

    - fixed bug in Shiplist


Version 0.4.8

    Stbof:

    - fixed bug in Lexicon
    - added functionality: one can now move ships in the shiplist more
       freely


Version 0.4.7

    - fixed bug in ShipGUI


Version 0.4.6

    Stbof:

    - fixed bug in TechGUI


Version 0.4.5

    Stbof:

    - added command: Group Edit Ship Stats


Version 0.4.4

    General:

    - minor improvements

    Stbof:

    - fixed bug in technology fields screen


Version 0.4.3

    General:

    - modified the menu

    Stbof:

    - improved ObjstrucGUI.java

    Snd:

    - SoundGUI now shows the index of the selected sound

    Mods:

    - added edit command: Files
    - mods can now install files in the game directory

Version 0.4.2

    Stbof:

    - fixed bug in saving In-Game Text files

Version 0.4.1

    Stbof:

    - added edit command: Major Empire's AI
    - fixed bug that currupted ship descriptions when moving ships
    - fixed bug in BldSet.java
    - fixed TextDataBase.java

Version 0.4.0

    Stbof:

    - added edit command: Ships


Version 0.3.9

    Stbof:

    - improved support for edifice.bst, 1 unknown byte less per building
    - maximum build cost for buildings is now 65535 as it should be
    - improved support for race.rst, 1 unknown byte less per race entry
    - fixed bug in LexiconGUI that threw an exception occasionaly
    - some data in shiplist.sst is checked for errors, when Check
      Integrity is used

    Snd:

    - fixed bug with replacing sounds in music.snd


Version 0.3.8

    Snd:

    - fixed bug with saving sfx.snd map
    - one can no longer add/remove files to/from the modified files
      list (it caused problems if you did)

    Mods:

    - fixed bug with the mod list


Version 0.3.7

    General:

    - no more duplicate entries of files in mod.lst
    - added the "List Of Modified Files" option for *.res
      and *.snd files
    - other minor improvements

    Stbof:

    - added a status box which displays a list of loaded files
      and files set to be removed under "Files"

    Snd:

    - the description search is no longer case sensitive

    Savegames:

    - fixed bug that caused the scan strenght not to be saved unless
      one deselected the sector first or selected another one

    Mods:

    - improved removal/installation
      (THIS BREAKS *.MOD FILES CREATED WITH EARLIER VERSIONS, THEY WILL
      INSTALL, BUT FAIL TO UNINSTALL PROPERLY.)


Version 0.3.6

    Stbof:

    - fixed bug with calculating building mask in RaceTech
    - fixed bug with re-loading *.tdb files
    - improved support for edifice.bst, 240 unknown bytes less ^_^
    - added checking of filename length when adding files
    - fixed UE not promting to save when user *only* added files
      to stbof.res

    Savegames:

    - fixed bug that corrupted the map when switching sectors at the
      borders of the map (there still seem to be some issues here)
    - fixed bug which over-wrote stellar object's animation prefix


Version 0.3.5

    Stbof:

    - fixed bug with adding new buildings in BldSetGUI
    - fixed problem with building descriptions


Version 0.3.4

    Stbof:

    - fixed bug that caused some manualy typed changes
      made to planet populations not to be saved
    - added edit command: Starting Conditions


Version 0.3.3


    Stbof:

    - added edit command: Starting Buildings
    - fixed bug with the major race mask in BuildingsGUI


Version 0.3.2

    Snd:

    - added option to export sound descriptions
      to a text file

    Stbof:

    - added some error checking for meplanet.bin


Version 0.3.1

    General:

    - redone the About window a slight bit

    Stbof:

    - added edit command: Buildings
    - fixed bug that caused edifbnft.bst
      not to be saved properly
    - fixed bug that caused a false error to be
      reported to user

    Savegames:

    - fixed bug: max morale value is 195 not 194

    Snd:

    - added sound descriptions for english.snd
    - improved the search function a little


Version 0.3.0

    General:

    - fixed connection reset by peer bug
      in game monitor


Version 0.2.9

    General:

    - fixed game monitor bug

    Snd:

    - fixed bug that caused music.snd not to be
      saved properly
    - added the Check Integrity option for all
      *.snd files


Version 0.2.8

    General:

    - added functionality: UE can now monitor
      a multiplayer game over a network and
      inform you if a crash occures


Version 0.2.7

    General:

    - added functionality: UE can now open
      sfx.snd and music.snd

    Mods:

    - changes to sfx.snd and music.snd are
      monitored and added to any mod being created


Version 0.2.6

    Stbof:

    - fixed bug that added all loaded files
      to the mod list
    - fixed bug with saving *.tdb files


Version 0.2.5

    General:

    - added functionality: UE can now open
      english.snd and german.snd

    Stbof:

    - fixed bug that caused edited animation
      delay time to be ignored
    - files can be managed 'on the fly',
      instead of apply, save changes as usual
    - one can now extract multiple files at once

    Mods:

    - changes to english.snd and german.snd are
      monitored and added to any mod being created


Version 0.2.4

    Stbof:

    - added edit command: Various In-Game Text
    - added simple search to Lexicon GUI

    Mods:

    - fixed bug that caused the destination flag
      not to be set on backups


Version 0.2.3

    General:

    - restructured and revised internal
      workings
    - Check Integrity checks for more
      errors.

    Stbof:

    - one can now extract frames as TGA
      images from animation files

    Mods:

    - empty folders in Data\User\Mods
      are removed after each mod
      removal/installation


Version 0.2.2

    Stbof:

    - fixed crc-32 bug

    Mods:

    - fixed IOException bug


Version 0.2.1

    General:

    - UE now treats the color RGB(248,0,248)
      in TGA's as transparent (same as botf)
    - other minor fixes

    Stbof:

    - planet population values are checked
      if negative

    Savegames:

    - one can now change player's empire

    Mods:

    - fixed bug that would cause overwrite
      error in some occasions


Version 0.2.0

    General:

    - fixed bug that caused certain edited
      info on certain occasions to be ignored
    - fixed bug with the TGA alpha channel
      twice - disabled alpha channel after
      realizing botf ignores it.
    - fixed bug that caused the open dialog
      not to show all available files
    - added functionality: one can now
      create/install/remove simple UE mods
    - other minor improvements and fixes

    Stbof:

    - fixed bug with description addresses
    - fixed bug that capped planet bonus
      values at 30%
    - added edit command: Technology

    Savegames:

    - fixed bug not showing scan strength for
      unrevealed sectors
    - added edit command: Game Info
